xmonad-contrib-0.17.1: Community-maintained extensions for xmonad

Copyright | (c) Brent Yorgey
License | BSD-style (see LICENSE)
Maintainer | <byorgey@gmail.com>
Stability | unstable
Portability | unportable
Safe Haskell | Safe-Inferred
Language | Haskell2010

XMonad.Layout.Reflect

Contents

- Usage

Description

Reflect a layout horizontally or vertically.

Synopsis

- reflectHoriz :: l a -> ModifiedLayout Reflect l a
- reflectVert :: l a -> ModifiedLayout Reflect l a
- data REFLECTX = REFLECTX
- data REFLECTY = REFLECTY
- data Reflect a

# Usage

You can use this module by importing it into your `~/.xmonad/xmonad.hs` file:

    import XMonad.Layout.Reflect

and modifying your layoutHook as follows (for example):

    layoutHook = reflectHoriz $ Tall 1 (3/100) (1/2)  -- put master pane on the right

`reflectHoriz` and `reflectVert` can be applied to any sort of layout (including Mirrored layouts) and will simply flip the physical layout of the windows vertically or horizontally.

XMonad.Layout.MultiToggle transformers are also provided for toggling layouts between reflected/non-reflected with a keybinding. To use this feature, you will also need to import the MultiToggle module:

    import XMonad.Layout.MultiToggle

Next, add one or more toggles to your layout. For example, to allow separate toggling of both vertical and horizontal reflection:

    layoutHook = mkToggle (single REFLECTX) $
                 mkToggle (single REFLECTY) $
                   (tiled ||| Mirror tiled ||| ...) -- whatever layouts you use

Finally, add some keybindings to do the toggling, for example:

    , ((modm .|. controlMask, xK_x), sendMessage $ Toggle REFLECTX)
    , ((modm .|. controlMask, xK_y), sendMessage $ Toggle REFLECTY)

reflectHoriz :: l a -> ModifiedLayout Reflect l a Source #

Apply a horizontal reflection (left <--> right) to a layout.

reflectVert :: l a -> ModifiedLayout Reflect l a Source #

Apply a vertical reflection (top <--> bottom) to a layout.

data REFLECTX Source #

Constructors

REFLECTX |

#### Instances

Instances details

Read REFLECTX Source # |
Instance details Defined in XMonad.Layout.Reflect Methods readsPrec :: Int -> ReadS REFLECTX Source # readList :: ReadS [REFLECTX] Source # readPrec :: ReadPrec REFLECTX Source # readListPrec :: ReadPrec [REFLECTX] Source #
Show REFLECTX Source # |
Instance details Defined in XMonad.Layout.Reflect Methods showsPrec :: Int -> REFLECTX -> ShowS Source # show :: REFLECTX -> String Source # showList :: [REFLECTX] -> ShowS Source #
Eq REFLECTX Source # |
Instance details Defined in XMonad.Layout.Reflect Methods (==) :: REFLECTX -> REFLECTX -> Bool Source # (/=) :: REFLECTX -> REFLECTX -> Bool Source #
Transformer REFLECTX Window Source # |
Instance details Defined in XMonad.Layout.Reflect Methods transform :: LayoutClass l Window => REFLECTX -> l Window -> (forall (l' :: Type -> Type). LayoutClass l' Window => l' Window -> (l' Window -> l Window) -> b) -> b Source #

data REFLECTY Source #

Constructors

REFLECTY |

#### Instances

Instances details

Read REFLECTY Source # |
Instance details Defined in XMonad.Layout.Reflect Methods readsPrec :: Int -> ReadS REFLECTY Source # readList :: ReadS [REFLECTY] Source # readPrec :: ReadPrec REFLECTY Source # readListPrec :: ReadPrec [REFLECTY] Source #
Show REFLECTY Source # |
Instance details Defined in XMonad.Layout.Reflect Methods showsPrec :: Int -> REFLECTY -> ShowS Source # show :: REFLECTY -> String Source # showList :: [REFLECTY] -> ShowS Source #
Eq REFLECTY Source # |
Instance details Defined in XMonad.Layout.Reflect Methods (==) :: REFLECTY -> REFLECTY -> Bool Source # (/=) :: REFLECTY -> REFLECTY -> Bool Source #
Transformer REFLECTY Window Source # |
Instance details Defined in XMonad.Layout.Reflect Methods transform :: LayoutClass l Window => REFLECTY -> l Window -> (forall (l' :: Type -> Type). LayoutClass l' Window => l' Window -> (l' Window -> l Window) -> b) -> b Source #

data Reflect a Source #

#### Instances

Instances details

LayoutModifier Reflect a Source # |

Instance details

Defined in XMonad.Layout.Reflect

Methods

modifyLayout :: LayoutClass l a => Reflect a -> Workspace WorkspaceId (l a) a -> Rectangle -> X ([(a, Rectangle)], Maybe (l a)) Source #

modifyLayoutWithUpdate :: LayoutClass l a => Reflect a -> Workspace WorkspaceId (l a) a -> Rectangle -> X (([(a, Rectangle)], Maybe (l a)), Maybe (Reflect a)) Source #

handleMess :: Reflect a -> SomeMessage -> X (Maybe (Reflect a)) Source #

handleMessOrMaybeModifyIt :: Reflect a -> SomeMessage -> X (Maybe (Either (Reflect a) SomeMessage)) Source #

pureMess :: Reflect a -> SomeMessage -> Maybe (Reflect a) Source #

redoLayout :: Reflect a -> Rectangle -> Maybe (Stack a) -> [(a, Rectangle)] -> X ([(a, Rectangle)], Maybe (Reflect a)) Source #

pureModifier :: Reflect a -> Rectangle -> Maybe (Stack a) -> [(a, Rectangle)] -> ([(a, Rectangle)], Maybe (Reflect a)) Source #

hook :: Reflect a -> X () Source #

unhook :: Reflect a -> X () Source #

modifierDescription :: Reflect a -> String Source #

modifyDescription :: LayoutClass l a => Reflect a -> l a -> String Source #

Read (Reflect a) Source # |
Instance details Defined in XMonad.Layout.Reflect Methods readsPrec :: Int -> ReadS (Reflect a) Source # readList :: ReadS [Reflect a] Source # readPrec :: ReadPrec (Reflect a) Source # readListPrec :: ReadPrec [Reflect a] Source #
Show (Reflect a) Source # |
Instance details Defined in XMonad.Layout.Reflect Methods showsPrec :: Int -> Reflect a -> ShowS Source # show :: Reflect a -> String Source # showList :: [Reflect a] -> ShowS Source #